﻿//////////////////////////////////////////////
// ScriptObjectReference.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class ScriptObjectInterpreterReference ;
	class ScriptObjectView ;
}

/// Includes ---------------------------------

// nkScripts
#include "../../Dll/DllDefines.h"

#include "../Functions/FunctionParameterType.h"

/// Internals --------------------------------

namespace nkScripts
{
	struct ScriptObjectReferenceStruct
	{
		ScriptObjectInterpreterReference* _reference = nullptr ;

		int _counter = 1 ;
	} ;
}

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT ScriptObjectReference final
	{
		private :

			// Attributes
			// Pointeur sur la zone mémoire
			ScriptObjectReferenceStruct* _structure ;

		private :

			// Functions
			// Mémoire
			void _release () ;

		public :

			// Constructeur, destructeur
			ScriptObjectReference () ;
			ScriptObjectReference (ScriptObjectInterpreterReference* reference) ;
			ScriptObjectReference (const ScriptObjectView& other) ;
			ScriptObjectReference (const ScriptObjectReference& other) ;
			ScriptObjectReference (ScriptObjectReference&& other) ;
			~ScriptObjectReference () ;

			// Getters
			ScriptObjectInterpreterReference* getInterpreterReference () const ;
			FUNCTION_PARAMETER_TYPE getType () const ;

			// Opérateurs
			ScriptObjectReference& operator= (const ScriptObjectView& other) ;
			ScriptObjectReference& operator= (const ScriptObjectReference& other) ;
			ScriptObjectReference& operator= (ScriptObjectReference&& other) ;
	} ;
}